package com.yfyy.iotx;

import org.eclipse.paho.client.mqttv3.MqttClient;
import org.eclipse.paho.client.mqttv3.MqttConnectOptions;
import org.eclipse.paho.client.mqttv3.MqttTopic;
import org.eclipse.paho.client.mqttv3.persist.MemoryPersistence;

import java.util.concurrent.ScheduledExecutorService;

/**
 * 订阅云飞的数据
 */
public class MqClient {

    private static final String HOST = "tcp://8.136.98.49:61883";
    private static String TOPIC1 = "";
    private static String clientid = "client";
    private MqttClient client;
    private MqttConnectOptions options;

    private String userName = "user";
    private String password = "f335bf402c655ee5fd2b5300905124e";
    
    @SuppressWarnings("unused")
    private ScheduledExecutorService scheduler;

    public MqClient(String deviceName) {
        this.TOPIC1 = "/yfkj/cbd/pub/" + deviceName;
        this.clientid = "client" + deviceName;
    }

    public void start() {
        try {
            // host为主机名，clientid即连接MQTT的客户端ID，一般以唯一标识符表示，MemoryPersistence设置clientid的保存形式，默认为以内存保存
            client = new MqttClient(HOST, clientid, new MemoryPersistence());
            // MQTT的连接设置
            options = new MqttConnectOptions();
            // 设置是否清空session,这里如果设置为false表示服务器会保留客户端的连接记录，设置为true表示每次连接到服务器都以新的身份连接
            options.setCleanSession(false);

            options.setUserName(userName);// 设置连接的用户名 //非必须
            options.setPassword(password.toCharArray());// 设置连接的密码 //非必须

            options.setConnectionTimeout(10);// 设置超时时间 单位为秒
            // 设置会话心跳时间 单位为秒 服务器会每隔1.5*20秒的时间向客户端发送个消息判断客户端是否在线，但这个方法并没有重连的机制
            options.setKeepAliveInterval(20);
            options.setAutomaticReconnect(true);// 自动重连


            // 设置回调
            client.setCallback(new MqPushCallback());

            MqttTopic topic = client.getTopic(TOPIC1);
            // setWill方法，如果项目中需要知道客户端是否掉线可以调用该方法。设置最终端口的通知消息
            // 遗嘱        options.setWill(topic, "close".getBytes(), 2, true);
            client.connect(options);

            // 订阅消息
            int[] Qos = {1};
            String[] topic1 = {TOPIC1};
            client.subscribe(topic1, Qos);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


}
